
## SEZIONE LINKS BUILD E SOURCE ##

# mi assicuro che i link simbolici ai sorgenti del kernel linux siano al loro posto
# per una possibile installazione di kernel-source
( cd lib/modules/3.18.6 ; rm -rf build )
( cd lib/modules/3.18.6 ; ln -sf /usr/src/linux-3.18.6 build )
( cd lib/modules/3.18.6 ; rm -rf source )
( cd lib/modules/3.18.6 ; ln -sf /usr/src/linux-3.18.6 source )

## SEZIONE RIGUARDANTE RC.MODULES ##

config() {
  NEW="$1"
  OLD="$(dirname $NEW)/$(basename $NEW .new)" #ottengo etc/rc.d/rc.modules-3.18.6
  # If there's no config file by that name, mv it over:
  if [ ! -r $OLD ]; then # NOT file exists and is readable
    mv $NEW $OLD
  elif [ "$(cat $OLD | md5sum)" = "$(cat $NEW | md5sum)" ]; then 
    #file rc.modules-3.18.6 gi presente nel sistema identico a quello del pacchetto
    #quindi posso cancellare il rc.modules-3.18.6.new
    rm $NEW
  fi
  # Altrimenti, esiste gi il file rc.modules-3.18.6 quindi NON lo sostituisco e quello
  # nuovo rc.modules-3.18.6.new sar lasciato per l'admin
}

#istallo (rinominando) nei casi opportuni
config etc/rc.d/rc.modules-3.18.6.new

# If rc.modules is a real file (NOT symbolic link), back it up:
if [ -r etc/rc.d/rc.modules -a ! -L etc/rc.d/rc.modules ]; then
  cp -a etc/rc.d/rc.modules etc/rc.d/rc.modules.bak 
fi
# Make rc.modules a symlink if it's not already, but do not replace
# an existing symlink.  You'll have to decide to point at a new version
# of this script on your own...
if [ ! -L etc/rc.d/rc.modules ]; then
  ( cd etc/rc.d ; rm -rf rc.modules )
  ( cd etc/rc.d ; ln -sf rc.modules-3.18.6 rc.modules )
fi
#se invece il file rc.modules  gi un link (anche se non punta a rc.modules-3.18.6) lo lascio

# A good idea whenever kernel modules are added or changed:
if [ -x sbin/depmod ]; then
  chroot . /sbin/depmod -a 3.18.6 1> /dev/null 2> /dev/null
fi

# aggiungo la "traccia" di rc.modules-* al pacchetto se  stato usato rc.modules-*.new incluso in kernel-image
# old: controllo che non sia stato rinominato in quel caso si perde la traccia perch non posso sapere il nuovo nome del pacchetto kernel-image
# if [ ! -f /etc/rc.d/rc.modules-3.18.6.new ] && [ -f /var/log/packages/kernel-image-3.18.6-x86_64-kpkg096 ]; then
#    echo "etc/rc.d/rc.modules-3.18.6" >> /var/log/packages/kernel-image-3.18.6-x86_64-kpkg096
# fi
# new: anche se rinomino il campo arch del pacchetto con la subarch la traccia di rc.modules-3.18.6 non viene persa e inoltre 
# viene eliminata quella del .new che non esiste dal precedente controllo nella funzione config.
# si basa sul rilevamento dell' ultimo pacchetto installato che  kernel-image (a meno di installazioni contemporanee di pacchetti)
if [ ! -f /etc/rc.d/rc.modules-3.18.6.new ] && \
   [ ! -z "$(cat "/var/log/packages/$(ls -t /var/log/packages/ | head -n 1)" | grep rc.modules-3.18.6.new)" ]; then
   sed -i "s/rc.modules-3.18.6.new/rc.modules-3.18.6/g" /var/log/packages/$(ls -t /var/log/packages/ | head -n 1)
fi

## SEZIONE RIGUARDANTE BOOTLOADER ## 

#converts ASCII character to its decimal value
char2dec()
{
 printf '%d' \"$1\"
}

# Find the device that holds the root partition:
find_root_dev()
{
 local ROOTDEV=$(cat /etc/fstab | tr '\t' ' ' | tr -s ' ' | grep -w / | cut -f1 -d' ')
 if [ "$(echo $ROOTDEV | cut -f1 -d=)" = "LABEL" -o "$(echo $ROOTDEV | cut -f1 -d=)" = "UUID" ]; then
    DKEY=$(echo $ROOTDEV | cut -f1 -d=)
    # The value can be LABEL=foo or LABEL='foo' or LABEL="foo"
    DVAL=$(echo $ROOTDEV | cut -f2 -d= | tr -d "'\042")
    ROOTDEV=$(/sbin/blkid | grep -w $DKEY | grep -w $DVAL | cut -f1 -d:)
 fi
 echo -n $ROOTDEV #es.: /dev/hda1
}

# Get the root fs information:
find_root_fs()
{
 local ROOTDEV=$(find_root_dev)
 if $(type vol_id 1>/dev/null 2>&1) ; then
   ROOTFS=$(vol_id $ROOTDEV | grep ID_FS_TYPE | cut -f2 -d=)
 else
   # Alternatively, use:
   ROOTFS=$(cat /etc/fstab | tr '\t' ' ' | tr -s ' ' | grep -w / | cut -f3 -d' ')
 fi
 echo -n $ROOTFS #es.: ext3
}

get_modules_most() 
{
  # parts of code is include on function add_modules_most() mkinitrd of Debian
  # Copyright (C) 2001-2003 Herbert Xu <herbert@debian.org>
  # Copyright (C) 2004-2005 Debian kernel Team <debian-kernel@lists.debian.org>

	if [ -n "$(find "/lib/modules/3.18.6/" -name '*.ko')" ]; then EXT="ko"; else EXT="o"; fi

	if [ -d "/lib/modules/3.18.6/kernel" ]; then
		set "/lib/modules/3.18.6"/kernel/drivers/video/fb*.$EXT
		[ -e "$1" ] && printf '%s\n' "$@"
		set "/lib/modules/3.18.6/"kernel/drivers/video/cfb*.$EXT
		[ -e "$1" ] && printf '%s\n' "$@"
		set "/lib/modules/3.18.6/"kernel/drivers/video/console/f*.$EXT
		[ -e "$1" ] && printf '%s\n' "$@"
		for i in \
			"/lib/modules/3.18.6/kernel/drivers/block" \
			"/lib/modules/3.18.6/kernel/drivers/ide" \
			"/lib/modules/3.18.6/kernel/drivers/md" \
			"/lib/modules/3.18.6/kernel/drivers/scsi" \
			"/lib/modules/3.18.6/kernel/fs" \
			"/lib/modules/3.18.6/kernel/net/unix"
		do
			[ -d "$i/" ] || continue
			find "$i/" -type f
                done | awk "
			!/fs\/binfmt_[^\/]*$/ &&
			!/fs\/autofs.*\/[^\/]*$/ &&
			!/fs\/coda\/[^\/]*$/ &&
			!/fs\/intermezzo\/[^\/]*$/ &&
			!/fs\/lockd\/[^\/]*$/ &&
			!/fs\/ncpfs.*\/[^\/]*$/ &&
			!/fs\/nfs.*\/[^\/]*$/ &&
			!/fs\/nls\/[^\/]*$/ &&
			!/fs\/ramfs\/[^\/]*$/ &&
			!/fs\/smbfs\/[^\/]*$/ &&
			!/drivers\/block\/loop\.$EXT$/ &&
			!/drivers\/block\/nbd\.$EXT$/ &&
			!/drivers\/block\/paride\/[^\/]*$/ &&
			!/drivers\/ide\/ide-cs\.$EXT$/ &&
			!/drivers\/ide\/ide-tape\.$EXT$/ &&
			!/drivers\/scsi\/ide-scsi\.$EXT$/ &&
			!/drivers\/scsi\/osst\.$EXT$/ &&
			!/drivers\/scsi\/pcmcia\/[^\/]*$/ &&
			!/drivers\/scsi\/ppa\.$EXT$/ &&
			!/drivers\/scsi\/scsi_debug\.$EXT$/ &&
			!/drivers\/scsi\/s[gt]\.$EXT$/ {
				print
			}
		"
		for i in \
			"/lib/modules/3.18.6/kernel/drivers/message/fusion/mptbase".* \
			"/lib/modules/3.18.6/kernel/drivers/message/fusion/mptscsih".*
		do
			[ -f "$i" ] || continue
			echo "$i"
		done
	fi | while read SRCMOD; do 
            MODULE=$(basename $SRCMOD .$EXT)
            echo -n "$MODULE:"
       done | sed "s/:$/\n/"
}

get_modules_dep() 
{
if [ "$(echo 3.18.6 | cut -c -3)" = "2.4" ]; then
cat << EoF > /tmp/modules.conf
   depfile=/lib/modules/3.18.6/modules.dep
   path[toplevel]=/lib/modules/3.18.6
   $(egrep -v '^(depfile|path\[toplevel\])=' /etc/modules.conf)
EoF
# imp: eof deve essere all'INIZIO della riga altrimenti non lo prende!
fi

MODULES=$1
# f s che lo stesso depmod se presente in 2 o pi moduli compaia una sola volta nella stringa restituita da questa funzione
MODULES_WITH_DEP=$MODULES 

if [ -n "$(find "/lib/modules/3.18.6/" -name '*.ko')" ]; then EXT="ko"; else EXT="o"; fi

  for MODULE in $(echo $MODULES | sed 's/:/ /g'); do 
    if [ "$(echo 3.18.6 | cut -c -3)" = "2.6" ]; then
         modprobe -q --set-version 3.18.6 --show-depends $MODULE
    elif [ "$(echo 3.18.6 | cut -c -3)" = "2.4" ]; then
         modprobe -C '/tmp/modules.conf' -nv $MODULE
    fi
  done | awk '{ print $2 }' | while read SRCMOD; do
                                DEPMOD=$(basename $SRCMOD .$EXT)
                                if ! echo $MODULES_WITH_DEP | grep -q $DEPMOD ; then
                                   MODULES_WITH_DEP="$MODULES_WITH_DEP:$DEPMOD"
                                   echo -n "$DEPMOD:"
                                fi
                           done | sed "s/:$//"
} 

get_modules_auto()
{
 #qui non uso $KERNELVERSION perch analizzo il sistema del kernel corrente per capire quali moduli servono al nuovo
 MLIST=""
 if [ -n "$(find "/lib/modules/$(uname -r)/" -name '*.ko')" ]; then EXT="ko"; else EXT="o"; fi

 # Determine the list of kernel modules needed to support the root device:
 # Walk the /sys tree finding kernel modules that are required for our storage
 MLIST=$(for i in $(find /sys/block -name "device" -exec ls -l {} \; | cut -f2 -d\> | cut -f3-5 -d/ | sort -u)
          do
           for j in $(find /sys/$i -name "modalias"); do
              (if [ "$(uname -r | cut -c -3)" = "2.6" ]; then
                  modprobe -q --show-depends $(cat $j)
              elif [ "$(uname -r | cut -c -3)" = "2.4" ]; then
                   modprobe -C '/etc/modules.conf' -nv $(cat $j)
              fi) 2>/dev/null | while read LINE ; do
                                     echo $(basename $(echo $LINE | cut -d' ' -f2) .$EXT )
                                done
           done
          done)
 # We need to 'undouble' the MLIST array. Some people report that walking the
 # /sys tree produces duplicate modules in the list.
 # The awk command elimitates doubles without changing the order.
 MLIST=$( echo $MLIST | tr ' ' '\n' | awk '!x[$0]++' | tr '\n' ' ' )
 MLIST=$( echo $MLIST | tr ' ' ':' )
 MLIST=${MLIST%:}  # To weed out a trailing ':' which was reported once.

 # Add the module(s) needed for the root filesystem:
 FSMOD=$(
          (if [ "$(uname -r | cut -c -3)" = "2.6" ]; then
              modprobe -q --show-depends $(find_root_fs)
          elif [ "$(uname -r | cut -c -3)" = "2.4" ]; then
               modprobe -C '/etc/modules.conf' -nv $(find_root_fs)
          fi) 2>/dev/null | while read LINE; do
         echo $(basename $(echo $LINE | cut -d' ' -f2) .$EXT )
       done)
 [ -n "$FSMOD" ] && MLIST="$MLIST:$(echo $FSMOD | tr ' ' ':')"

 echo -n $MLIST
}

# mkinitrd di slack 11 NON supporta -C/-L/-R ma non dovrebbe dare errore, vengono ignorati (questo perch 
# l'mkinitrd di Pat quando non riconosce un'opzione passa ad esaminare la sucessiva)
# mkinitrd di slack >= 12 gi aggiunge i moduli necessari per le opzioni -C/-L/-R
options_extra_support()
{
 USING_LVM=0
 USING_LUKS=0
 USING_RAID=0
 REALDEV=""   # The device that contains the LUKS volume
 BASEDEV=""   # Lowest level device (raw block device or RAID volume)
 ROOTDEV=$(find_root_dev)

 # Is the root partition on a (combination of) LVM/LUKS volume?
 if $( lvdisplay -c $ROOTDEV 1>/dev/null 2>/dev/null ); then
    # Our root partition is on a LV:
    USING_LVM=1
    # Search the Physical Volume of our Logical Volume:
    MYVG=$( echo $(lvdisplay -c $ROOTDEV) | cut -d: -f2 )
    for LINE in $(pvdisplay -c) ; do
        VG=$(echo $LINE | cut -d: -f2)
        [ "$VG" = "$MYVG" ] && break
    done 
    PV=$(echo $LINE | cut -d: -f1)
    # Check if there is a LUKS device underneath:
    if $( cryptsetup status $PV 1>/dev/null 2>/dev/null ) ; then
       # Our root partition's LV  is on a LUKS volume:
       USING_LUKS=1
       REALDEV=$( cryptsetup status $PV | grep 'device: ' | tr -d ' ' | cut -d: -f2 )
       BASEDEV=$REALDEV
    else
       BASEDEV=$PV
    fi
 elif $( cryptsetup status $ROOTDEV 1>/dev/null 2>/dev/null ) ; then
      # Our root device is on a LUKS volume:
      USING_LUKS=1
      REALDEV=$( cryptsetup status $ROOTDEV | grep 'device: ' | tr -d ' ' | cut -d: -f2 )
      ROOTDEV=$(basename $ROOTDEV)
      # Check for LVM:
      for LV in $(lvdisplay -c | tr -d ' ' | cut -f1 -d:) ; do
          # Note: cryptsetup shows the real device, whereas 
          # lvdisplay requires the /dev/<myvg>/... symlink to the real device.
          if [ "$(readlink $LV)" = "$REALDEV" ]; then
             REALDEV=$LV
             break
          fi
      done
      if $( lvdisplay -c $REALDEV 1>/dev/null 2>/dev/null ); then
         # Our root partition's LUKS device is on a LV:
         USING_LVM=1
         # Search the Physical Volume of our Logical Volume:
         MYVG=$( echo $(lvdisplay -c $REALDEV) | cut -d: -f2 )
         for LINE in $(pvdisplay -c) ; do
             VG=$(echo $LINE | cut -d: -f2)
             [ "$VG" = "$MYVG" ] && break
         done 
         PV=$(echo $LINE | cut -d: -f1)
         BASEDEV=$PV
      else
         BASEDEV=$REALDEV
      fi
 else
    BASEDEV=$ROOTDEV
fi

 # Finally, we should check if base device is
 # a real block device or a RAID volume:
 for MD in  $(cat /proc/mdstat | grep -w active | cut -d' ' -f1) ; do
     if [ "$BASEDEV" = "/dev/$MD" ]; then
        USING_RAID=1
        break
     fi
 done

 MKINITRD_COMMAD_APPEND=""
 if [ $USING_LUKS -eq 1 ]; then
    MKINITRD_COMMAD_APPEND="$MKINITRD_COMMAD_APPEND -C $REALDEV"
 fi
 if [ $USING_LVM -eq 1 ]; then
    MKINITRD_COMMAD_APPEND="$MKINITRD_COMMAD_APPEND -L"
 fi
 if [ $USING_RAID -eq 1 ]; then
    MKINITRD_COMMAD_APPEND="$MKINITRD_COMMAD_APPEND -R"
 fi

 echo -n $MKINITRD_COMMAD_APPEND
}

wrapper_mkinitrd_all()
{
 INITRD_MODULES_LIST=$(find "/lib/modules/3.18.6/" -type f -printf "%f:" | sed "s/.ko//g" | sed "s/:$/\n/")
 mkinitrd -c -k 3.18.6 -m "${INITRD_MODULES_LIST}" \
          -f $(find_root_fs) -r $(find_root_dev) $(options_extra_support) -o /boot/initrd-3.18.6.gz > /dev/null 2>&1
}

wrapper_mkinitrd_most()
{
 INITRD_MODULES_LIST=$(get_modules_most)
 INITRD_MODULES_LIST_DEP="$(get_modules_dep $INITRD_MODULES_LIST)"
 mkinitrd -c -k 3.18.6 -m "${INITRD_MODULES_LIST}:${INITRD_MODULES_LIST_DEP}" \
          -f $(find_root_fs) -r $(find_root_dev) $(options_extra_support) -o /boot/initrd-3.18.6.gz > /dev/null 2>&1
}

wrapper_mkinitrd_auto()
{
 INITRD_MODULES_LIST=$(get_modules_auto)
 mkinitrd -c -k 3.18.6 -m "${INITRD_MODULES_LIST}" \
          -f $(find_root_fs) -r $(find_root_dev) $(options_extra_support) -o /boot/initrd-3.18.6.gz > /dev/null 2>&1
}

wrapper_mkinitrd()
{
 INITRD_MODULES_LIST_DEP="$(get_modules_dep $INITRD_MODULES_LIST)"
 mkinitrd -c -k 3.18.6 -m "${INITRD_MODULES_LIST}:${INITRD_MODULES_LIST_DEP}" \
          -f $(find_root_fs) -r $(find_root_dev) $(options_extra_support) -o /boot/initrd-3.18.6.gz > /dev/null 2>&1
}

print_new_entry_lilo()
{
 echo
 echo "## Autogenerated by kernel-image build with kernelpkg tool ##"
 echo "image = /boot/vmlinuz-3.18.6"
 if [ "$INITRD" = "on" ]; then
    echo "initrd = /boot/initrd-3.18.6.gz"
 fi
 echo "root = $(find_root_dev)"
 echo "label = 3.18.6 #(15 characters max)"
 echo "read-only"
 echo "## you remove manually when use removepkg with kernel-image package ##"
}

print_new_entry_grub()
{
 ROOT_DEV_LINUX_FORMAT=$(find_root_dev | sed 's/\/dev\///g') #es.: hda1
 HD_NUMBER=$(( $(char2dec "$(echo $ROOT_DEV_LINUX_FORMAT | cut -c 3)") - $(char2dec "a") ))
 HD_PARTITION_NUMBER=$(( $(echo $ROOT_DEV_LINUX_FORMAT | cut -c 4) - 1))
 ROOT_DEV_GRUB_FORMAT="(hd$HD_NUMBER,$HD_PARTITION_NUMBER)" #grub ha sempre "hd" sia per hd ide, sata e scsi!
 echo
 echo "## Autogenerated by kernel-image build with kernelpkg tool ##" 
 echo "title 3.18.6"
 echo "root $ROOT_DEV_GRUB_FORMAT"
 echo "kernel /boot/vmlinuz-3.18.6 root=$(find_root_dev) ro"
 if [ "$INITRD" = "on" ]; then
    echo "initrd /boot/initrd-3.18.6.gz"
 fi
 echo "## you remove manually when use removepkg with kernel-image package ##"
}

# - Bootloder primario e secondari - #
# il bootloder "principale"  sempre sull' MBR del disco di boot (in genere hda o sda)
# il tool rileva SOLO il bootloder "principale" in questione non bootloader "secondari" 
# (installati su una partizione e richiamati al boot dal bootloader principale)
# - Device del bootloder primario - #
# il bootloader primario , sta sempre su primary master boot record , quindi a meno che non sia stato 
# invertito l' ordine di avvio dei dischi nel bios, risiede nel disco 0, settore 0, traccia 0 (hda/sda di conseguenza).
# - Geometria del Master Boot Record - #
# The first sector (512 bytes) is the MBR and consists of, 446 bytes bootloader, 64 bytes partition table 
# and a 2 byte signature (0xAA55) which the BIOS requires for a proper boot loader. It get its name because 
# it is the first boot record that is loaded, which can then load other boot records from various locations on the disk.

detect_bootloader_on_mbr()
{
 bootloader_on_mbr="unknown"
 check=0

 for dev_i in $(cat /proc/partitions | awk '{print $4}' | egrep "^(h|s){1}d[a-z]{1}$") # ls /sys/block | grep -e "^[sh]d.$"
 do
   for bootloader in "lilo" "grub" "yaboot" "elilo"
   do
     if [ ! -z "$(dd if=/dev/$dev_i bs=446 count=1 2> /dev/null | strings | grep -i "$bootloader")" ]; then
        case $bootloader in
             "lilo")   FILECONF="/etc/lilo.conf"      ;;
             "grub")   FILECONF="/boot/grub/menu.lst" ;;
             "yaboot") FILECONF="/etc/yaboot.conf"    ;;
             "elilo")  FILECONF="/etc/elilo.conf"     ;;
        esac
        if [ -f $FILECONF ] && [ ! -z "$(cat $FILECONF | grep "$(find_root_dev)")" ]; then
           bootloader_on_mbr=$bootloader
           check=1
           break
        fi
     fi
   done
   if [ $check = 1 ]; then
      break
   fi
 done

 echo $bootloader_on_mbr
}

# ridefinizione variabili initrd e eventuale creazione dell' initrd effettivo
INITRD=off
INITRD_MODULES_LIST=""
if [ "$INITRD" = "on" ]; then

   ( echo )
   ( echo "+===============================================================================" )
   ( echo "|Build initrd image file." )
   ( echo "+===============================================================================" )
   ( echo )

   if [ "$INITRD_MODULES_LIST" = "MOST" ]; then
      wrapper_mkinitrd_most
   elif [ "$INITRD_MODULES_LIST" = "AUTO" ]; then
      wrapper_mkinitrd_auto
   elif [ "$INITRD_MODULES_LIST" = "ALL" ]; then
      wrapper_mkinitrd_all
   else
      wrapper_mkinitrd
   fi
fi

# ridefinisco le variabili all'interno di doist.sh per maggior facilit nella modifica della stesso a pacchetto gi creato
DISABLE_BOOTLOADER=off
BOOTLOADER=lilo

if [ "$DISABLE_BOOTLOADER" != "on" ]; then

   # activate automatically detection
   if [ "$BOOTLOADER" = "detect" ]; then
      BOOTLOADER=$(detect_bootloader_on_mbr)
      if [ "$BOOTLOADER" = "unknown" ]; then 

         ( echo )
   	 ( echo "+===============================================================================" )
   	 ( echo "|[WARNING] bootloader unknown, add new entry is impossible." )
   	 ( echo "+===============================================================================" )
   	 ( echo )

         exit 1
      fi
   fi
   # else not use detection: static define

   ( echo )
   ( echo "+===============================================================================" )
   ( echo "|Analyze your \"$BOOTLOADER\" bootloader configuration, and if necessary, " )
   ( echo "|add new entry." )
   ( echo "+===============================================================================" )
   ( echo )

   # Quando viene trovata una corrispondenza, viene eseguita la lista di comandi corrispondente. 
   # Dopo il primo confronto riuscito, non ne vengono controllati altri dei successivi. Quindi non serve break.

   case $BOOTLOADER in
       "lilo")    FILECONF="/etc/lilo.conf"
                  if [ -f $FILECONF ] && [ -z "$(cat $FILECONF | egrep "^ *label *= *3.18.6")" ]; then
                     print_new_entry_lilo >> $FILECONF
                     /sbin/lilo
                  fi
                  ;;

       "grub")    FILECONF="/boot/grub/menu.lst"
                  if [ -f $FILECONF ] && [ -z "$(cat $FILECONF | egrep "^ *title *3.18.6")" ]; then
                     print_new_entry_grub >> $FILECONF
                  fi
                  ;;

       "yaboot")  #yaboot (for ppc computer) derives from lilo
                  FILECONF="/etc/yaboot.conf"
                  if [ -f $FILECONF ] && [ -z "$(cat $FILECONF | egrep "^ *label *= *3.18.6")" ]; then
                     print_new_entry_lilo >> $FILECONF
                     /sbin/ybin
                  fi
                  ;;
       "elilo")   #elilo derives from lilo and is for new apple (intel based) with efi 
                  FILECONF="/etc/elilo.conf"
                  if [ -f $FILECONF ] && [ -z "$(cat $FILECONF | egrep "^ *label *= *3.18.6")" ]; then
                     print_new_entry_lilo >> $FILECONF
                     /sbin/elilo --efiboot
                  fi
                  ;;
   esac

fi

exit 0

